//////////////////////////////////////////////////////////////////
//Fluchtdiagramm der Standardmap
//Methode: Es wird bei hier 50 Iterationen der maximale Abstand der y-Werte 
//zur Codierung der Farbe verwendet.
//Mit Linksklick zweifache Vergrößerung
//Mit Rechtsklick Trajektorie am Ort. (Fluchtdiagramm wird transparent)
//Auf die verschiedenen Informationen im Bild bei Links- und Rechtsklick achten!
//Trajektorien werden nur im Bereich 0 < x < 2*PI und -PI < y < PI angezeigt.
//Bis zu 1 000 000 -fache Vergrößerungen sind möglich
/////////////////////////////////////////////////////////////////

double xmin = 0; 
double xmax;
double ymin = -Math.PI; 
double ymax;
double wh = 2*Math.PI;
int iterations = 50; //Anzahl der Iterationen

double yMin, yMax;//zur Initialisierung von ymin und ymax

double K = 0.971635;
//double K = 0.5;//Alternative
PImage bild, bildGedreht, bildZurueckGedreht;
//PGraphics hier zu verwenden, mag umständlich erscheinen. Wir nutzen es hier, um den Sketch einfach
//auf multithreaded umzuschreiben
PGraphics pg;
float vFaktor = 1  ;
boolean zeichnen,trajektZeichnen, schonTransparent, achseZeichnen, bildFertig;
double x0,y0;
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
int xK, yK; //Koordinaten der Punkte
int i,  M;

int w = 640; int h = 640; 
double   xH, yH; 
 //double xSpecial , ySpecial;//zu Testzwecken

void setup() {
  background(255);
  colorMode(HSB);
  i=0;
  M = 100000;//Anzahl der Punkte auf einer Trajektorie (ohne Zoom)
  zeichnen = true;
  
  size(640, 640);
  
  pg = createGraphics(width,height);
 
  bild = createImage(width,height,HSB);
  bildGedreht = createImage(width,height,HSB);
  bildZurueckGedreht = createImage(width,height,HSB);
  trajektZeichnen = false;
  schonTransparent = false;
  achseZeichnen = true;
  bildFertig = false;
  zeichneFluchtdiagramm(xmin,ymin,wh);
 
}
//////////////////////////////////////////////////////////////
void draw() {
 ///////////////////////////////////////////////////
 if(zeichnen){
   
   image(pg,0,0);
  //Initialisierung der PImages
   bild = get();
   bildGedreht = get();
   bildZurueckGedreht = get();
 
   //weil negativer y-Bereich bisher oben ist: Spiegelung an x-Achse:
  
     for (int i = 0; i < bild.width; i++){
        for (int j = 0; j < bild.height; j++) {
             bildGedreht.set(i,j,bild.get(i,bild.height-j-1));
            
        }
      }

    image(bildGedreht,0,0);  
    bildFertig = true;
    zeichnen = false;  
   
   }

   ////////////////////////////////////////
   if(bildFertig){
      bildFertig = false;
      background(255);
      //tint(255, 160); //aktivieren, wenn die Trajektorien hervorgehoben werden sollen
      image(bild,0,0);
      for (int i = 0; i < bild.width; i++){
        for (int j = 0; j < bild.height; j++) {
             bildZurueckGedreht.set(i,j,bild.get(i,bild.height-j-1));
        }
      }
      background(255);    
      image(bildZurueckGedreht,0,0);
   
       if(achseZeichnen){
          //Zu Beginn einmal Achsen zeichnen
          stroke(255,100);
          line(w/2,0,w/2,h);  
          line(0,h/2,w,h/2);
          achseZeichnen = false;
     }   
   } 
   ////////////////////////////////////////////
}
/////////////////////////////////////////////////////
void zeichneFluchtdiagramm(double xmin, double ymin, double wh){
   pg.beginDraw();
      pg.loadPixels();
        this.wh = wh;
        this.xmin = xmin;
        this.ymin = ymin;
        double xmax = xmin + wh;
       // println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println("y: "+ymin,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / width;
        double dy = (ymax - ymin) / height;
      
        double y = ymin;
        for (int j = 0; j < height; j++) {
          double x = xmin;
          for (int i = 0; i < width; i++) {
            double D = standardMapIteration(x, y, iterations);
            pg.pixels[i+j*width] = colorize(D);       
         
            x += dx;
          }   
          y += dy;
        }
         pg.updatePixels();     
    pg.endDraw();   
  
}

/////////////////////////////////////////////////////////////
color colorize(double dist) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
   color col; 
      dist = dist%256;
      
       col = color((int)(dist),255,255); 
       //alternativ:
       //col = color((int)(dist+128)%255,255,(int)(6*dist)%255);   
    return col; 
  
}
/////////////////////////////////////////////////////////////////////
double standardMapIteration(double xH, double yH, int maxN) {
   yMin = 5;
   yMax =-5;
  //Standardmap Algorithmus zur Berechung des Abstand des Originalpunktes zum Punkt nach maxN Iterationen
  int  maxit = maxN;
  double d = 0;
  x0 = xH; y0=yH; 
  xAlt = xH; yAlt = yH;
 
  int i = 0;
  while (i < maxit) {
    yNeu = (yAlt + K*Math.sin(xAlt)) ;
    xNeu = (xAlt + yNeu) ;  
    //Der Wertebereich wird hier nicht auf den Definitionsbereich eingeschränkt (modulo)
    //weil sonst die Abstandswerte d sinnlos werden können.
  //  d = d +Math.sqrt((xAlt-xNeu)*(xAlt-xNeu)+(yAlt-yNeu)*(yAlt-yNeu)); 
      if(yNeu < yMin)  yMin = yNeu;
    if(yNeu > yMax)  yMax = yNeu;
    xAlt = xNeu;yAlt = yNeu;
    
    i++;
  }
   d = 200*(yMax-yMin); 
  return d;
 
}

/////////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  i=0;
  this.K =K;
  xK = yK =0;
  xAlt = (float)xH; 
  yAlt = (float)yH;
  M =   N;
  strokeWeight(1);
  stroke(0);
  while(i <=M){  
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu) % (2*Math.PI);  
       if(xNeu <0) xNeu = 2*Math.PI+xNeu;//damit  xNeu > 0
       yK = round( map((float)yNeu,(float)ymin,(float)ymax,h,0));                 
       xK = round (map((float)xNeu,(float)xmin,(float)xmax,0,w));  
       point(xK,yK);  
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }  
  i=0;   
}

/////////////////////////////////////////////////////////////////
void mousePressed() {
  
  if (mouseButton == LEFT) {
      println(ymin);
     zeichnen = true;  
     achseZeichnen = false;
     background(255);
   
    // berechne, wo der Mauszeiger im gezeigten Ausschnitt der 
    // Zahlenebene ist (Transformation Pixelposition nach (x,y))
    double x = xmin + wh*mouseX/width;
    double y = ymin + wh*(height-mouseY)/height;//negativer y-Wert muss unten sein
   
     vFaktor = 2*vFaktor; 
     println("Zoomfaktor: "+vFaktor+"-fach"); 
    
     wh*=0.5;
     // bestimme den neuen gezeigten Ausschnitt
    xmin = x-wh/2.0;
    ymin = y-wh/2.0; println(xmin,ymin,wh);
    M = M + 100000;//damit auch bei Vergrößerungen genügend Punkte der Trajektorien gezeichnet werden
    zeichneFluchtdiagramm(xmin,ymin,wh);
    
  }
    
  if (mouseButton == RIGHT) {
      bild = get();     
     image(bild,0,0); 
     xH = map(mouseX,0,w,(float)xmin,(float)(xmin+wh)); 
     yH = map(mouseY,h,0, (float)ymin,(float)(ymin+wh));

     xmin= (float)xmin; xmax= (float)(xmin+wh);
     ymin =(float)ymin; ymax= (float)(ymin+wh);
   
     iteriere(xH,yH,M,K);    
  }

 
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  
  if (key == 's') save("standardMapFlucht.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
